#ifndef EFL_EVENT_HOLD_EO_HH
#define EFL_EVENT_HOLD_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_event.eo.h"
#include "efl_event_hold.eo.h"
#include "efl_event_input.eo.h"
#include "efl_input_device.eo.h"
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_event.eo.hh"
#include "efl_event_input.eo.hh"
#include "efl_input_device.eo.hh"
#include "eo_base.eo.hh"
namespace efl { namespace event { 
struct Hold;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::event::Hold> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace event { 
struct Hold {
   ::efl::eolian::return_traits<bool>::type hold_get() const;
   ::efl::eolian::return_traits<void>::type hold_set( ::efl::eolian::in_traits<bool>::type val) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_EVENT_HOLD_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::event::Hold() const;
   operator ::efl::event::Hold&();
   operator ::efl::event::Hold const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Hold,  ::efl::Event,  ::efl::event::Input,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Hold const ,  ::efl::Event const ,  ::efl::event::Input const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace event { 
struct Hold : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Event)
   , EO_CXX_INHERIT( ::efl ::event::Input)
   , EO_CXX_INHERIT( ::eo::Base)
{
   explicit Hold( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Hold(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Hold(Hold const& other) = default;
   Hold(Hold&& other) = default;
   Hold& operator=(Hold const& other) = default;
   Hold& operator=(Hold&& other) = default;
   Hold()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Hold( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Hold(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<bool>::type hold_get() const;
   ::efl::eolian::return_traits<void>::type hold_set( ::efl::eolian::in_traits<bool>::type val) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_EVENT_HOLD_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Hold,  ::efl::Event,  ::efl::event::Input,  ::eo::Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Hold const ,  ::efl::Event const ,  ::efl::event::Input const ,  ::eo::Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Hold) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Hold>::value, "");
} } 
#include "efl_event_hold.eo.impl.hh"
#endif
